# ================================================================

use strict;

# ================================================================

my($tTargetCategory)=&sanitize(&decodeAsURL($main::gQueryURL{$main::iQuery_category}));

my(@tRecord)=&getAllRecord($main::iDataFile,1);

my(@tCategoryArray)=();

for(my($tCount1)=0;$tCount1<=($#tRecord);$tCount1++)
{
	my($tCurrentCategory)=&decodeAsURL($tRecord[$tCount1]{$main::iQuery_category});

	if(&isDifferent($tCurrentCategory,''))
	{
		push(@tCategoryArray,&separate($tCurrentCategory));
	}
}

my(%tCategoryArrayFolded)=&foldArrayWithScore(\@tCategoryArray);

$main::gHeader.=&getHTTPResponse200Header();
$main::gHeader.=$main::gExtraHTTPHeader;
$main::gHeader.=&getHTTPContentHeader($main::lContentLanguage,$main::lCharset);

$main::gBody.=&getHTMLDocumentOpen($main::iTitle,$main::lContentLanguage,$main::lCharset,\@main::iCSSFile);
$main::gBody.=&getDumpIfExists($main::iNoticeFile);

my($tBookmarklet)="javascript:window.location='".$main::gURL.'?'.$main::iQuery_action.'='.$main::iAction_execute_add.'&'.$main::iQuery_title."='+encodeURIComponent(document.title)+'".'&'.$main::iQuery_url."='+encodeURIComponent(location.href);";

my($tLoginLogoutURL)=($main::gIsLogin)?($main::gURL.'?'.$main::iQuery_action.'='.$main::iAction_execute_logout):($main::gURL.'?'.$main::iQuery_action.'='.$main::iAction_display_login);
my($tLoginLogoutName)=($main::gIsLogin)?($main::lLogout):($main::lLogin);

$main::gBody.=&getHTMLCaption($main::iTitle,1);
$main::gBody.=&getHTMLParagraphOpen();
$main::gBody.='<a href="'.$tBookmarklet.'">'.$main::lBookmarklet.'</a> / <a href="'.$tLoginLogoutURL.'">'.$tLoginLogoutName.'</a>'."\n";
$main::gBody.=&getHTMLParagraphClose();
$main::gBody.=&getHTMLLine();

my($tTotalCount)=($#tRecord)+1;

if(&isSame($tTargetCategory,''))
{
	$main::gBody.='<strong>'.$main::lUnfiltered.'('.$tTotalCount.')</strong>';
}
else
{
	$main::gBody.='<a href="'.$main::gURL.'?'.$main::iQuery_action.'='.$main::iAction_display_list.'">'.$main::lUnfiltered.'('.$tTotalCount.')</a>';
}

foreach(sort keys %tCategoryArrayFolded)
{
	my($tKey)=$_;
	my($tValue)=$tCategoryArrayFolded{$tKey};

	$main::gBody.=' / ';

	if(&isSame($tKey,$tTargetCategory))
	{
		$main::gBody.='<strong>'.$tKey.'('.$tValue.')</strong>';
	}
	else
	{
		$main::gBody.='<a href="'.$main::gURL.'?'.$main::iQuery_action.'='.$main::iAction_display_list.'&'.$main::iQuery_category.'='.&encodeAsURL($tKey).'">'.$tKey.' ('.$tValue.')</a>';
	}
}

for(my($tCount1)=0;$tCount1<=($#tRecord);$tCount1++)
{
	my($tCurrentCategory)=&sanitize($tRecord[$tCount1]{$main::iQuery_category});
	my($tCurrentComment)=&sanitize($tRecord[$tCount1]{$main::iQuery_comment});
	my($tCurrentID)=&sanitize($tRecord[$tCount1]{$main::iQuery_id});
	my($tCurrentTitle)=&sanitize($tRecord[$tCount1]{$main::iQuery_title});
	my($tCurrentTime)=&sanitize($tRecord[$tCount1]{$main::iQuery_time});
	my($tCurrentURL)=&sanitize($tRecord[$tCount1]{$main::iQuery_url});

	my(@tCurrentCategoryArray)=&separate($tCurrentCategory);

	if((&isSame($tTargetCategory,''))||(&hasSame($tTargetCategory,\@tCurrentCategoryArray)))
	{
		$main::gBody.=&getHTMLLine();
		$main::gBody.=&getHTMLParagraphOpen();
		$main::gBody.='<a href="'.$tCurrentURL.'" target="_blank">'.$tCurrentTitle.'</a><br>'."\n";
		$main::gBody.=$tCurrentCategory.' '.$tCurrentTime.'<br>'."\n";
		$main::gBody.='<a href="'.$tCurrentURL.'" target="_blank">'.$tCurrentURL.'</a>'."\n";
		$main::gBody.=&getHTMLParagraphClose();

		if(&isDifferent($tCurrentComment,''))
		{
			$main::gBody.=&getHTMLParagraphOpen();
			$main::gBody.=$tCurrentComment."\n";
			$main::gBody.=&getHTMLParagraphClose();
		}

		if($main::gIsLogin)
		{
			my($tUpdateURL)=$main::gURL.'?'.$main::iQuery_action.'='.$main::iAction_display_update.'&'.$main::iQuery_id.'='.$tCurrentID;
			my($tDeleteURL)=$main::gURL.'?'.$main::iQuery_action.'='.$main::iAction_execute_delete.'&'.$main::iQuery_id.'='.$tCurrentID;

			$main::gBody.=&getHTMLParagraphOpen();
			$main::gBody.='<a href="'.$tUpdateURL.'">'.$main::lUpdate.'</a> / <a href="'.$tDeleteURL.'">'.$main::lDelete.'</a><br>'."\n";
			$main::gBody.=&getHTMLParagraphClose();
		}
	}
}

$main::gBody.=&getHTMLDocumentCloseWithApplicationVersion($main::iApplicationName,$main::iApplicationVersion,$main::iLibraryVersion);

# ================================================================

1;
