# ================================================================

use strict;

# ================================================================

require $main::iScriptBase.'Function_Shared.pl';

# ================================================================

require $main::iScriptBase.'version.txt';

# ================================================================

my($tAcceptLanguage)=$ENV{'HTTP_ACCEPT_LANGUAGE'};

if(&isContained($tAcceptLanguage,'ja'))
{
	require $main::iScriptBase.'Language_ja.txt';
}
elsif(&isContained($tAcceptLanguage,'en'))
{
	require $main::iScriptBase.'Language_en.txt';
}
else
{
	require $main::iScriptBase.'Language_en.txt';
}

# ================================================================

our($iQuery_action)       = 'action';
our($iQuery_category)     = 'category';
our($iQuery_comment)      = 'comment';
our($iQuery_id)           = 'id';
our($iQuery_message)      = 'message';
our($iQuery_password)     = 'password';
our($iQuery_redirect_url) = 'redirect_url';
our($iQuery_session_id)   = 'session_id';
our($iQuery_time)         = 'time';
our($iQuery_title)        = 'title';
our($iQuery_url)          = 'url';
our($iQuery_user_id)      = 'user_id';

# ================================================================

our($iAction_display_about)  = 'display_about';
our($iAction_display_list)   = 'display_list';
our($iAction_display_login)  = 'display_login';
our($iAction_display_update) = 'display_update';

our($iAction_execute_add)    = 'execute_add';
our($iAction_execute_delete) = 'execute_delete';
our($iAction_execute_login)  = 'execute_login';
our($iAction_execute_logout) = 'execute_logout';
our($iAction_execute_update) = 'execute_update';

# ================================================================

our($gHeader)='';
our($gBody)='';

our($gSessionID)='';
our($gURL)=&getScriptURL();
our(%gCookie)=&getCookieEntries();
our(%gQueryURL)=&getURLQueryEntries(0);
our(%gQueryRefererURL)=&getRefererURLQueryEntries(0);
our(%gQueryPost)=&getPostQueryEntries(0);

my($tOldSessionID)=$gCookie{$main::iQuery_session_id};

if(&isSame($tOldSessionID,''))
{
	$gSessionID=&createSession();
}
else
{
	$gSessionID=&updateSession($tOldSessionID);
	&deleteOldSession();
}

our($gExtraHTTPHeader)=&getCookieWithoutExpire($main::iQuery_session_id,$gSessionID);

our($gIsLogin)=&isDifferent(&getSessionVariable($gSessionID,$iQuery_user_id),'');

my($tAction)=$gQueryURL{$iQuery_action};

if(!$gIsLogin)
{
	if($main::iPublicMode)
	{
		if(&isSame($tAction,''))
		{
			require $main::iScriptBase.'Module_display_list.pl';
		}
		elsif(&isSame($tAction,$iAction_display_about))
		{
			require $main::iScriptBase.'Module_display_about.pl';
		}
		elsif(&isSame($tAction,$iAction_display_list))
		{
			require $main::iScriptBase.'Module_display_list.pl';
		}
		elsif(&isSame($tAction,$iAction_display_login))
		{
			require $main::iScriptBase.'Module_display_login.pl';
		}
		elsif(&isSame($tAction,$iAction_execute_add))
		{
			require $main::iScriptBase.'Module_display_login.pl';
		}
		elsif(&isSame($tAction,$iAction_execute_login))
		{
			require $main::iScriptBase.'Module_execute_login.pl';
		}
		else
		{
			$gHeader.=&getHTTPResponse200Header();
			$gHeader.=$gExtraHTTPHeader;
			$gHeader.=&getHTTPContentHeader($main::lContentLanguage,$main::lCharset);

			$gBody.=&getHTMLDocumentOpen($main::iTitle,$main::lContentLanguage,$main::lCharset,\@main::iCSSFile);
			$gBody.=&getHTMLUnknownAction();
			$gBody.=&getHTMLDocumentCloseWithApplicationVersion($main::iApplicationName,$main::iApplicationVersion,$main::iLibraryVersion);
		}
	}
	else
	{
		if(&isSame($tAction,''))
		{
			require $main::iScriptBase.'Module_display_login.pl';
		}
		elsif(&isSame($tAction,$iAction_display_about))
		{
			require $main::iScriptBase.'Module_display_about.pl';
		}
		elsif(&isSame($tAction,$iAction_display_list))
		{
			require $main::iScriptBase.'Module_display_login.pl';
		}
		elsif(&isSame($tAction,$iAction_display_login))
		{
			require $main::iScriptBase.'Module_display_login.pl';
		}
		elsif(&isSame($tAction,$iAction_execute_add))
		{
			require $main::iScriptBase.'Module_display_login.pl';
		}
		elsif(&isSame($tAction,$iAction_execute_login))
		{
			require $main::iScriptBase.'Module_execute_login.pl';
		}
		else
		{
			$gHeader.=&getHTTPResponse200Header();
			$gHeader.=$gExtraHTTPHeader;
			$gHeader.=&getHTTPContentHeader($main::lContentLanguage,$main::lCharset);

			$gBody.=&getHTMLDocumentOpen($main::iTitle,$main::lContentLanguage,$main::lCharset,\@main::iCSSFile);
			$gBody.=&getHTMLUnknownAction();
			$gBody.=&getHTMLDocumentCloseWithApplicationVersion($main::iApplicationName,$main::iApplicationVersion,$main::iLibraryVersion);
		}
	}
}
else
{
	if(&isSame($tAction,''))
	{
		require $main::iScriptBase.'Module_display_list.pl';
	}
	elsif(&isSame($tAction,$iAction_display_about))
	{
		require $main::iScriptBase.'Module_display_about.pl';
	}
	elsif(&isSame($tAction,$iAction_display_list))
	{
		require $main::iScriptBase.'Module_display_list.pl';
	}
	elsif(&isSame($tAction,$iAction_display_update))
	{
		require $main::iScriptBase.'Module_display_update.pl';
	}
	elsif(&isSame($tAction,$iAction_execute_add))
	{
		require $main::iScriptBase.'Module_execute_add.pl';
	}
	elsif(&isSame($tAction,$iAction_execute_delete))
	{
		require $main::iScriptBase.'Module_execute_delete.pl';
	}
	elsif(&isSame($tAction,$iAction_execute_logout))
	{
		require $main::iScriptBase.'Module_execute_logout.pl';
	}
	elsif(&isSame($tAction,$iAction_execute_update))
	{
		require $main::iScriptBase.'Module_execute_update.pl';
	}
	else
	{
		$gHeader.=&getHTTPResponse200Header();
		$gHeader.=$gExtraHTTPHeader;
		$gHeader.=&getHTTPContentHeader($main::lContentLanguage,$main::lCharset);

		$gBody.=&getHTMLDocumentOpen($main::iTitle,$main::lContentLanguage,$main::lCharset,\@main::iCSSFile);
		$gBody.=&getHTMLUnknownAction();
		$gBody.=&getHTMLDocumentCloseWithApplicationVersion($main::iApplicationName,$main::iApplicationVersion,$main::iLibraryVersion);
	}
}

&printResponseCache($gHeader,$gBody);

# ================================================================

1;
